/*
 *  Interactive disassembler (IDA).
 *  TheHyper VM Processor Module.
 *
 *  (c) 2006 Rolf Rolles
 */

#ifndef __TH_HPP
#define __TH_HPP

#include "reg.hpp"

static char *TH_regnames[] =
{
    "rESPb",
    "rESPw",
    "rESP",
    
    "r01b",
    "r01w",
    "r01",
    
    "r02b",
    "r02w",
    "r02",
    
    "r03b",
    "r03w",
    "r03",
    
    "r04b",
    "r04w",
    "r04",
    
    "r05b",
    "r05w",
    "r05",
    
    "r06b",
    "r06w",
    "r06",
    
    "r07b",
    "r07w",
    "r07",
    
    "r08b",
    "r08w",
    "r08",
    
    "r09b",
    "r09w",
    "r09",
    
    "r0Ab",
    "r0Aw",
    "r0A",
    
    "r0Bb",
    "r0Bw",
    "r0B",
    
    "r0Cb",
    "r0Cw",
    "r0C",
    
    "r0Db",
    "r0Dw",
    "r0D",
    
    "r0Eb",
    "r0Ew",
    "r0E",
    
    "r0Fb",
    "r0Fw",
    "r0F"
};

inline const char *TH_Regname(unsigned long width, unsigned long regnum)
{
    return TH_regnames[TH_Regnum(width, regnum)];
}

#define o_vmmem      o_idpspec0      // heap key in x.addr
#define o_vmmemderef o_idpspec1      // heap key in x.addr

#endif
