/*
 *  Interactive disassembler (IDA).
 *  TheHyper VM Processor Module.
 *
 *  (c) 2006 Rolf Rolles
 */

#ifndef __REGISTERS_HPP
#define __REGISTERS_HPP

#include "../idaidp.hpp"

enum TH_regs
{
    rESPb = 0,
    rESPw,
    rESP,
    
    r01b,
    r01w,
    r01,
    
    r02b,
    r02w,
    r02,
    
    r03b,
    r03w,
    r03,
    
    r04b,
    r04w,
    r04,
    
    r05b,
    r05w,
    r05,
    
    r06b,
    r06w,
    r06,
    
    r07b,
    r07w,
    r07,
    
    r08b,
    r08w,
    r08,
    
    r09b,
    r09w,
    r09,
    
    r0Ab,
    r0Aw,
    r0A,
    
    r0Bb,
    r0Bw,
    r0B,
    
    r0Cb,
    r0Cw,
    r0C,
    
    r0Db,
    r0Dw,
    r0D,
    
    r0Eb,
    r0Ew,
    r0E,
    
    r0Fb,
    r0Fw,
    r0F,
    
    rVcs, // fake registers for segmentation
    rVds, // fake
    rEND
};

TH_regs TH_Regnum(unsigned long width, unsigned long regnum);
ea_t get_keyed_address(unsigned long key);

#define PLFM_TH 0x829A

#endif
